#ifndef code__json__pointer_hxx_
#define code__json__pointer_hxx_

#include <code/json/exception.hxx>
#include <code/json/optional.hxx>
#include <code/json/read.hxx>
#include <code/json/variant.hxx>

#include <queue>
#include <string>

namespace code::json {

class pointer {
public:
  explicit
  pointer(std::string const& expression);

  optional< variant >
  read(variant const& source) const;

  void
  write(variant& target, variant value) const;

  friend
  std::string
  to_string(pointer const& ptr);

private:
  std::queue< std::string >
  parse_refs(std::string const& expression);

  std::queue< std::string > refs_;
};

std::string
to_string(pointer const& ptr);

} // namespace code::json

#endif
